/******************************************************************************
*
* official project name:  CPoker 92Plus
* project language:       TI-GCC / English
* author:                 Greg S. <inittab@unixdev.net>
* file title:             CAllDef.h
* initial file date:      ** unknown **
* file purpose:           main header file for game. includes all functions,
*                          defines, values, or types used in the coding.
*
*******************************************************************************/

#ifndef __CALLDEF_H
  #define __CALLDEF_H

  #define USE_TI92PLUS
  #define USE_V200

  #include <nostub.h> //include file for anti-kernel extremist organizations
  #include <all.h> //include file for everything else

  struct cSTRING {
    char *data;
  };
  
  //the following value may be changed to change the initial value
  #define defaultMoney 10000 //default amount of money (max:4,294,967,295; min:1)

  /* The following keys are CURRENTLY supported by waitKey(). */
  #define keyNum0 0 //key '0'
  #define keyNum1 1 //key '1'
  #define keyNum2 2 //key '2'
  #define keyNum3 3 //key '3'
  #define keyNum4 4 //key '4'
  #define keyNum5 5 //key '5'
  #define keyNum6 6 //key '6'
  #define keyNum7 7 //key '7'
  #define keyNum8 8 //key '8'
  #define keyNum9 9 //key '9'
  #define keyClear 10 //key 'Clear'
  #define keyBack 11 //key '<-'
  #define keyEsc 264 //key ESC
  #define keyEnter 13 //key 'Enter' (RETURN)

  #define PK_NOTHING 0
  #define PK_THREEOFAKIND 3 //three of a kind
  #define PK_TWOPAIRS 2 //two pairs
  #define PK_ONEPAIR 1 //one pair
  #define PK_STRAIGHT 4 //straight
  #define PK_FLUSH 5 //flush
  #define PK_FOUROFAKIND 7 //four of a kind
  #define PK_FULLHOUSE 6 //full house
  #define PK_ROYALFLUSH 9 //royal flush!
  #define PK_STRAIGHTFLUSH 8 //straight flush

  //| Forward Declarations |//
  //* -- CDrawing.c -- *//
   /*Graphics Drawing*/
  void PxlVert(int); //column
  void PxlHorz(int); //row
  void DrawBox(int,int,int,int,int); //x,y,x2,y2,mode
   /*Full Screen*/
  void DrawFullScreen(unsigned long,unsigned long); //money, wager
  void dispSuite(int,int); //who, what
   /*Modify Cards*/
  void DrawCard(int,int,int,int); //num, pic, ltor, topbot
  void shadeSelNum(int); //ltor
  void ClearCard(int); //ltor
  //* -- CMisc.c -- *//
   /*Card Testing*/
  int determineSuite(int[],int[], int*); //num array[5], pic array[5]
  char checkForDblCard(int[],int[]); //nums, pics
   /*Other*/
  CALLBACK short cmpfunc(const void*, const void*); //comparison function for qsort [descending]
  void Text(char*); //message
  //* -- CKeyboard.c -- *//
  unsigned short waitKey(char*);
  void pause(void);
  void waitForKeyUp(void);
  //* -- CDialogs.c -- *//
  unsigned short ShowMenu(char*,struct cSTRING[],int,int,char*);
  unsigned long ShowDialog(unsigned long,void*);
  //* -- waitms.c -- *//
  #define WaitForMillis __waitms
  void WaitForMillis(unsigned int);
#endif
