/******************************************************************************
*
* official project name:  CPoker 92Plus
* project language:       TI-GCC / English
* author:                 Greg S. <inittab@unixdev.net>
* file title:             CDialogs.c
* initial file date:      ** unknown **
* file purpose:           replacements for TIs pop-up menu & request dialog
*
*******************************************************************************/
#include "CAllDef.h"
//This displays a pop-up menu with up to 8 items. It returns keyNum1 -> keyNum8,
// or keyEsc. You can press 1 -> 8, or ESC, and each option will be labeled
// '1:,2:,...' accordingly. The only drawback is that I don't erase the graphics
// when finished; this is for obvious reasons. Assign strings to each cSTRING.data
// in the 'Options' array of length 'Len'. Send width in pixels to 'width'. Send
// pop-up title to 'Title'. 'taskbar' is a string for the satusline; pass "" to leave the
// status line unaffected
unsigned short ShowMenu(char *Title, struct cSTRING Options[], int Len, int width, char *taskbar) {
  int i;
  char *msg;
  char c[30];
  unsigned short k;
  int height = 10+(8*Len);
  int y = (128-height)/2;
  int x = (240-width)/2;

  if (Len > 8 || Len < 1) return 0;
  DrawBox(x, y, x+width, y+height, A_REVERSE);
  DrawLine(x, y+8, x+width, y+8, A_REVERSE);
  for (i=y+9; i <= (y+height)-1; i++) DrawLine(x+1,i,(x+width)-1,i,A_REVERSE);

  FontSetSys(F_4x6);
  DrawStr((240-(strlen(Title)*4))/2, y+2, Title, A_REVERSE);
  FontSetSys(F_6x8);
  for (i=0; i <= Len-1; i++) {
   sprintf(c, "%i: %s", i+1, Options[i].data);
   DrawStr((240-width)/2+1, (i*8)+y+10, c, A_NORMAL);
  }

  msg = taskbar;
ReKey:
  k = waitKey(msg);
  msg = ""; //.. so waitKey won't refresh on loop
  if ((k <= keyNum1+(Len-1) &&
       k >= keyNum1) ||
      k == keyEsc) return k;
  goto ReKey;
}

unsigned long ShowDialog(unsigned long money, void *ESCbuffer) {
  int i;
  char *msg;
  char wager[10];
  unsigned long wager2=0;
  unsigned short key;

  memset(ESCbuffer, 78, 1); //'N'
  PxlHorz(0); PxlHorz(8); PxlHorz(10);
  FontSetSys(F_4x6);
  DrawStr(103, 2, "Poker 92", A_NORMAL);
  FontSetSys(F_6x8);
  DrawStr(1, 15, "You Have:", A_NORMAL);
  printf_xy(110, 15, "$%lu", money);
  DrawStr(1, 28, "Place Your Wager:", A_NORMAL);
  DrawLine(114, 26, 239, 26, A_NORMAL);
  DrawLine(114, 26, 114, 36, A_NORMAL);
  DrawLine(114, 36, 239, 36, A_NORMAL);
  DrawBox(33, 43, 102, 54, A_THICK1);
  DrawPix(103, 55, A_NORMAL); //fix for DrawBox / A_THICK1
  DrawBox(136, 43, 205, 54, A_THICK1);
  DrawPix(206, 55, A_NORMAL); //fix for DrawBox / A_THICK1
  DrawStr(38, 46, "Enter = OK", A_NORMAL);
  DrawStr(141, 46, "ESC=CANCEL", A_NORMAL);
  i = 0; //counter < 10
  msg = "TYPE + [ENTER]=OK AND [ESC]=CANCEL";
  memset(&wager, 32, 10); //fill wager string with 10 spaces (char 32)
keys:
  key = waitKey(msg);
  msg = ""; //so status does not refresh on loop
  if (key == keyEnter) {
    goto endOfFunc;
  }
  else if (key == keyEsc) {
    memset(ESCbuffer, 89, 1); //'Y'
    goto endOfFunc;
  }
  else if (key == keyBack) {
    if (i != 0) {
      --i;
      wager[i] = 32;
    }
  }
  else if (i == 10 || key == keyClear) {
    goto keys;
  }
  else {
    wager[i] = (char)key+48;
    ++i;
  }
  DrawStr(116, 28, wager, A_REPLACE);
  goto keys;
endOfFunc:
  wager2 = (unsigned long)atol(wager);
  ClearScreen();
  return wager2;
}
