/******************************************************************************
*
* official project name:  CPoker 92Plus
* project language:       TI-GCC / English
* author:                 Greg S. <inittab@unixdev.net>
* file title:             CMisc.c
* initial file date:      ** unknown **
* file purpose:           miscellaneous functions
*
*******************************************************************************/

#include "CAllDef.h"

int determineSuite(int p1[], int p2[], int *sub) { //should be flawless
    int q=PK_NOTHING, additions=0, i;

    //at least one pair
    if (p1[0]==p1[1] || p1[1]==p1[2] || p1[2]==p1[3] || p1[3]==p1[4]) {
        if ((p1[0]==p1[1] && p1[1]==p1[2]) ||
            (p1[1]==p1[2] && p1[2]==p1[3]) ||
            (p1[2]==p1[3] && p1[3]==p1[4])) {
                q=PK_THREEOFAKIND;
                if ((p1[0]==p1[1] && p1[1]==p1[2] && p1[2]==p1[3]) ||
                    (p1[1]==p1[2] && p1[2]==p1[3] && p1[3]==p1[4])) {
                        q=PK_FOUROFAKIND;
                }
                else if ((p1[0]==p1[1] && p1[1]==p1[2] && p1[2]!=p1[3] && p1[3]==p1[4]) ||
                         (p1[0]==p1[1] && p1[1]!=p1[2] && p1[2]==p1[3] && p1[3]==p1[4])) {
                        q=PK_FULLHOUSE;
                }
        }
        else if ((p1[0]==p1[1] && p1[2]==p1[3]) ||
                 (p1[1]==p1[2] && p1[3]==p1[4]) ||
                 (p1[0]==p1[1] && p1[3]==p1[4])) {
                q=PK_TWOPAIRS;
        }
        else {
                q=PK_ONEPAIR;
        }
    } //straight
    else if (p1[0]==p1[1]+1 && p1[1]==p1[2]+1 && p1[2]==p1[3]+1 && p1[3]==p1[4]+1)
        q=PK_STRAIGHT;

    //same suite    
    if (p2[0]==p2[1] && p2[1]==p2[2] && p2[2]==p2[3] && p2[3]==p2[4]) {
        if (p1[0]==13 && p1[1]==12 && p1[2]==11 && p1[3]==10 && p1[4]==01 && p2[0]==3) {
                q=PK_ROYALFLUSH;
        }
        else if (p1[0]==p1[1]+1 && p1[1]==p1[2]+1 && p1[2]==p1[3]+1 && p1[3]==p1[4]+1) {
                q=PK_STRAIGHTFLUSH;
        }
        else if (q < PK_FLUSH)
                q=PK_FLUSH;
    }
    
    //establish the tie-breaker
    sub[0] = 0;
    switch (q) {
        case PK_TWOPAIRS:
            for (i = 0; i < 5-1; i++) {
                if (p1[i] == p1[i+1] && sub[0] != p1[i]) {
                    additions++;
                    sub[0] += p1[i];
                    if (additions == 2)
                        break;
                }
            }
            break;

        case PK_THREEOFAKIND:
        case PK_ONEPAIR:
        case PK_FOUROFAKIND:
            for (i = 0; i < 5-1; i++) {
                if (p1[i] == p1[i+1]) {
                    sub[0] = p1[i]; //found a duplicate, use it
                    break;
                }
            }
            break;
        
        default:
            for (i = 0; i < 5; i++) {
                sub[0] += p1[i]; //sum of all cards
            }
            break;
    }
    
    return q;
}

char checkForDblCard(int nums[], int pics[]) {
  if ((nums[0]==nums[1] && pics[0]==pics[1]) ||
      (nums[0]==nums[2] && pics[0]==pics[2]) ||
      (nums[0]==nums[3] && pics[0]==pics[3]) ||
      (nums[0]==nums[4] && pics[0]==pics[4]) ||
      (nums[1]==nums[2] && pics[1]==pics[2]) ||
      (nums[1]==nums[3] && pics[1]==pics[3]) ||
      (nums[1]==nums[4] && pics[1]==pics[4]) ||
      (nums[2]==nums[3] && pics[2]==pics[3]) ||
      (nums[2]==nums[4] && pics[2]==pics[4]) ||
      (nums[3]==nums[4] && pics[3]==pics[4]))
   return 't';
  else
   return 'f';
}

CALLBACK short cmpfunc(const void *a, const void *b) { //comparison function for qsort [descending]
  return *(int*)b - *(int*)a; //note: typecasts are necessary
}

void Text(char *msg) {
  int strWid=strlen(msg)*6;
  int x=(239-strWid)/2;
  int y=59;

  ClearScreen();
  FontSetSys(F_6x8);
  DrawStr(x, y, msg, A_NORMAL);
  DrawBox(x-2, y-2, x+strWid+2, y+8, A_NORMAL);
  pause();
}
