/******************************************************************************
*
* official project name:  CPoker 92Plus
* project language:       TI-GCC / English
* author:                 Greg S. <inittab@unixdev.net>
* file title:             Poker.c
* initial file date:      ** unknown **
* file purpose:           main file
*
*******************************************************************************/

#include "CAllDef.h"

//int _ti92plus; //produce .9XZ file

void _main(void) {
  /* misc */
  unsigned short result; //result of message box
  int deal_you; //loop var for determining suites
  char *msg; //used with waitKey
  char *c=" "; //ESCbuffer for dialog
  static int quitVar=0; //0=normal - 1=ESC
  unsigned short key;
  /* money */
  static unsigned long money=defaultMoney; //amount of money (PERMANENT!)
  char wager[10]="          "; //10 spaces for wager requst box
  static unsigned long wager2=0; //integer version of above
  /* loops */
  int i; //used in various loops as an iNTEGER
  int temp; //counter for array loops
  /* suite status buffers */
  int suiteNum; //storage of hand priority (0<9)
  int youSuite=0, delSuite=0; //temporary status placement vars
  int youSub, delSub;
  /* suite arrays */
  int backup0[5], backpic[5]; //temporary storage for you (testing only)
  static int backup[5]={0,0,0,0,0}; //temporary storage of card numbers
  static int younums[5]={0,0,0,0,0}, youpics[5]={0,0,0,0,0}; //permanent storage of your cards
  int dealnums[5], dealpics[5]; // ... of dealers cards
  struct cSTRING cs[4];
  /* used to wait for kb on exit */
  unsigned int k;
  //the following three lines are a replacement for SAVE_SCREEN, because it kept
  // the 'busy' indicator on.
  LCD_BUFFER buffer;
  ST_busy(ST_IDLE);
  LCD_save(buffer);

  randomize();
  ClearScreen();
  if (quitVar != 0) { //ESC was used to leave game
    FontSetSys(F_6x8);
    quitVar=0;
    DrawFullScreen(money, wager2);
    for (i=0; i<=4; i++) {
      DrawCard(backup[i], youpics[i], i+1, 1);
      if (younums[i]>13) shadeSelNum(i+1);
    }
    goto pausekey;
  }
  FontSetSys(F_8x10);
  for (i=145; i >= -1; i--) DrawStr(i, 60, "SchenzelSoft ", A_REPLACE);
  for (i=-8; i <= 64; i++) DrawStr(i, 60, " SchenzelSoft", A_REPLACE);
  WaitForMillis(2048);

start:
  MoveTo(0, 0);
  memset((void *)0x4C00, 255, 3840); //turns screen black; change 255 to 0 for ClearScreen();
  FontSetSys(F_8x10);
  DrawStr(1, 2, "Poker 92 - Main Menu", A_REVERSE);
  DrawLine(2, 12, 160, 12, A_REVERSE); //underline to above

  cs[0].data = "Play New Game";
  cs[1].data = "Play Saved Game";
  cs[2].data = "Instructions";
  cs[3].data = "Exit";
  result = ShowMenu("Poker 92", cs, 4, 110, "Welcome to Poker 92 by Greg S.");
  if (result == keyNum4 || result == keyEsc) goto exit1;
  if (result == keyNum3) goto instruct;
  if (result == keyNum2) goto saved;
  if (result == keyNum1) goto new;

instruct:
  ClearScreen();
  PxlHorz(6); PxlHorz(121);
  MoveTo(0, 8);
  FontSetSys(F_4x6);
  DrawStr(64, 0, "Poker 92 is written & maintained by Greg Schenzel.", A_NORMAL);
  FontSetSys(F_6x8);
  printf("* Hit 1-5 to select the corresponding\n   card for trading. You can trade any\n   cards.\n\n");
  printf("* Press [ENTER] when you are done\n   trading cards.\n\n");
  printf("* Press [ESC] to abort the game\n   immediately. You will return to the\n   program that you ran it from (or the\n   home screen).\n\n");
  pause();
  goto start;
  
new:
  money=defaultMoney;

saved:
  ClearScreen();
  if (money==0) {
   Text("GAME OVER");
   goto exit1;
  }

  wager2 = ShowDialog(money, c);
  if (memcmp(c, "Y", 1) == 0) goto start; //esc was pressed
  if (wager2==0 || wager2>money) goto saved; //wager not correct
  DrawFullScreen(money, wager2);

inityou: //Cards
  for (i=0; i<=4; i++) {
    younums[i]=random(13)+1;
    youpics[i]=random(4)+1;
  }

  if (checkForDblCard(younums, youpics)=='t') {
    goto inityou;
  }
  else {
    for (i=0; i<=4; i++) {
      DrawCard(younums[i], youpics[i], i+1, 1);
      backup[i]=younums[i];
    }
  }

pausekey:
  msg = "USE 1,2,3,4,5 TO SELECT THE CARDS TO TRADE + [ENTER]=OK";
  (150);
loop:
  key = waitKey(msg);
  msg = "";
  if (key == keyEsc) { //check for escape
      quitVar=1; //comeback on next startup
      goto exit1;
  }
  else if (key == keyNum5) { //check for f5
      if (younums[4]==18) {
       younums[4]=backup[4];
      }
      else {
       younums[4]=18; //above 13
      }
      shadeSelNum(5);
  }
  else if (key == keyNum4) { //check for f4
      if (younums[3]==17) {
       younums[3]=backup[3];
      }
      else {
       younums[3]=17; //above 13
      }
      shadeSelNum(4);
  }
  else if (key == keyNum3) { //check for f3
      if (younums[2]==16) {
       younums[2]=backup[2];
      }
      else {
       younums[2]=16; //above 13
      }
      shadeSelNum(3);
  }
  else if (key == keyNum2) { //check for f2
      if (younums[1]==15) {
       younums[1]=backup[1];
      }
      else {
       younums[1]=15; //above 13
      }
      shadeSelNum(2);
  }
  else if (key == keyNum1) { //check for f1
      if (younums[0]==14) {
       younums[0]=backup[0];
      }
      else {
       younums[0]=14; //above 13
      }
      shadeSelNum(1);
  }
  else if (key == keyEnter) { // check for enter
      goto enter;
  }
  else if (key == keyClear) {
      asm("trap #4"); //same as off(); but probably smaller code
  }
  (150);
  goto loop;

enter:
  ST_helpMsg("PLEASE WAIT...");
  for (i=0; i<=4; i++) {
    if (younums[i]>13) {
      do {
        younums[i]=random(13)+1;
        youpics[i]=random(4)+1;
        backup[i]=younums[i];
        if (checkForDblCard(younums, youpics)=='f') break;
      } while (1);
      ClearCard(i+1);
      DrawCard(younums[i], youpics[i], i+1, 1);
    }
  }

dealer:
  for (i=0; i<=4; i++) {
      dealnums[i]=random(13)+1;
      dealpics[i]=random(4)+1;
  }
  if (checkForDblCard(dealnums, dealpics)=='t') goto dealer;
  if ((dealnums[0]==younums[0] && dealpics[0]==youpics[0]) ||
      (dealnums[0]==younums[1] && dealpics[0]==youpics[1]) ||
      (dealnums[0]==younums[2] && dealpics[0]==youpics[2]) ||
      (dealnums[0]==younums[3] && dealpics[0]==youpics[3]) ||
      (dealnums[0]==younums[4] && dealpics[0]==youpics[4])) goto dealer;
  if ((dealnums[1]==younums[0] && dealpics[1]==youpics[0]) ||
      (dealnums[1]==younums[1] && dealpics[1]==youpics[1]) ||
      (dealnums[1]==younums[2] && dealpics[1]==youpics[2]) ||
      (dealnums[1]==younums[3] && dealpics[1]==youpics[3]) ||
      (dealnums[1]==younums[4] && dealpics[1]==youpics[4])) goto dealer;
  if ((dealnums[2]==younums[0] && dealpics[2]==youpics[0]) ||
      (dealnums[2]==younums[1] && dealpics[2]==youpics[1]) ||
      (dealnums[2]==younums[2] && dealpics[2]==youpics[2]) ||
      (dealnums[2]==younums[3] && dealpics[2]==youpics[3]) ||
      (dealnums[2]==younums[4] && dealpics[2]==youpics[4])) goto dealer;
  if ((dealnums[3]==younums[0] && dealpics[3]==youpics[0]) ||
      (dealnums[3]==younums[1] && dealpics[3]==youpics[1]) ||
      (dealnums[3]==younums[2] && dealpics[3]==youpics[2]) ||
      (dealnums[3]==younums[3] && dealpics[3]==youpics[3]) ||
      (dealnums[3]==younums[4] && dealpics[3]==youpics[4])) goto dealer;
  if ((dealnums[4]==younums[0] && dealpics[4]==youpics[0]) ||
      (dealnums[4]==younums[1] && dealpics[4]==youpics[1]) ||
      (dealnums[4]==younums[2] && dealpics[4]==youpics[2]) ||
      (dealnums[4]==younums[3] && dealpics[4]==youpics[3]) ||
      (dealnums[4]==younums[4] && dealpics[4]==youpics[4])) goto dealer;
  for (i=0; i<=4; i++) DrawCard(dealnums[i], dealpics[i], i+1, 2);

  for (deal_you=1; deal_you<=2; deal_you++) {
      if (deal_you==1) {
       for (i=51; i<=59; i++) DrawLine(4, i, 172, i, A_REVERSE);
       for (i=0; i<=4; i++) {
        backup[i]=younums[i];
        backpic[i]=youpics[i];
       }
      }
      else {
       for (i=103; i<=111; i++) DrawLine(4, i, 172, i, A_REVERSE);
       for (i=0; i<=4; i++) {
        backup[i]=dealnums[i];
        backpic[i]=dealpics[i];
       }
      }
      qsort(backup, 5, sizeof(int), cmpfunc); //For Card Testing <SORTS CARDS DESCENDING>
      //Card Testing
      suiteNum=determineSuite(backup, backpic, deal_you==1 ? &youSub : &delSub);
      dispSuite(deal_you, suiteNum);
      if (deal_you==1) {
        for (temp=0; temp<5; temp++)
          backup0[temp]=backup[temp];
        youSuite=suiteNum;
      }
      else {
        delSuite=suiteNum;
      }
  }

  (150);
  pause();
  ClearScreen();
  if (youSuite>delSuite) {
      Text("YOU WIN");
      money += wager2;
      goto saved;
  }
  else if (youSuite<delSuite) {
      Text("DEALER WINS");
      money -= wager2;
      goto saved;
  }
  else if (youSuite==delSuite) { //check for highest card
      if (youSub > delSub) {
        Text("YOU WIN");
        money += wager2;
        goto saved;
      }
      else if (delSub > youSub) {
        Text("DEALER WINS");
        money -= wager2;
        goto saved;
      }
      else {
        Text("A TIE!");
        goto saved;
      }
  }

exit1:
  waitForKeyUp();
  OSSetSR(0x0700);
  LCD_restore(buffer);
//  while (!OSdequeue(&k, (void *)kbd_queue()));
  return;
}
