/******************************************************************************
*
* project name:    TI-Chess
* file name:       waitms.c
* initial date:    27/07/2000
* authors:         thomas.nussbaumer@gmx.net (coding)
*                  marcos.lopez@wol.es (design/graphics/beta testing)
* description:     utility function which "waits" a given number of
*                  milliseconds
*
* $Id: waitms.c,v 1.2 2000/08/12 15:31:13 Thomas Nussbaumer Exp $
*
*******************************************************************************/
//NOTE: This file is unmodified by Greg S.; it was "donated" by Thomas Nussbaumer.

#ifndef WAIT_FOR_MILLIS_C
#define WAIT_FOR_MILLIS_C

/*===========================================================================*/
/* "waits" a given number of milliseconds (dummy looping)                    */
/* NOTE: this wait loop is parametrized to fit on HW1 calculators            */
/*===========================================================================*/

asm("      xdef __waitms
__waitms:  movem.l %d0-%d3,-(%sp)
           move.w (20,%sp),%d2
           move.l #31,%d1
           move.l #31,%d3
_wl2_:     move.w #150,%d0    /* modify this value for exact timing !!! */
_wl1_:     rol.l  %d3,%d1
           dbra   %d0,_wl1_
           dbra   %d2,_wl2_
           movem.l (%sp)+,%d0-%d3
           rts");
#endif

//#############################################################################
//###################### NO MORE FAKES BEYOND THIS LINE #######################
//#############################################################################
//
//=============================================================================
// Revision History
//=============================================================================
//
// $Log: waitms.c,v $
// Revision 1.2  2000/08/12 15:31:13  Thomas Nussbaumer
// substitution keywords added
//
